N = 12; % sensors
K = 3; % no. of interferers
snr_db = 12; % signal-to-noise ratio in dB
snapshots = 50;
rep=10;
sinr=zeros(snapshots,rep);

d = 0.5;

phase = linspace(10, 90, K); 

for l=1:rep
theta=(rand(1,4)-0.5); theta=theta/std(theta)*2; theta=theta+10;
phi0=rand(1)*pi/4; phi=[phi0 phi0+pi/4 phi0+pi/2 phi0+3*pi/4];

Am=zeros(N,K);
for n=1:N
    Am(n,:)=exp(j*2*pi*d*sin(phase*pi/180)*(n-1));
    b1(n)=exp(j*2*pi*d*sin(theta(1)*pi/180)*(n-1));
    b2(n)=exp(j*2*pi*d*sin(theta(2)*pi/180)*(n-1));
    b3(n)=exp(j*2*pi*d*sin(theta(3)*pi/180)*(n-1));
    b4(n)=exp(j*2*pi*d*sin(theta(4)*pi/180)*(n-1)); 
end
Am(:,1)=Am(:,1)+0.1*exp(j*phi(1))*b1.'+0.1*exp(j*phi(2))*b2.'+0.1*exp(j*phi(3))*b3.'+0.1*exp(j*phi(4))*b4.';
Am = Am/sqrt(N);

sector=[5 15];
range=[linspace(sector(1),sector(2),101)];
sv=exp(j*2*pi*d*[0:N-1]'*sin(range*pi/180));
C=sv*sv'/101;
dn=2;
[U0 G0]=eig(C);
U=U0(:,N-dn+1:N);
P=U*U';

s=ones(K,1);
s(2:K)=0.1;

snr=exp(snr_db*log(10)/10);
s_n=s(1)/sqrt(snr);

I = eye(N);
R_estimate=zeros(N,N);
S_estimate=zeros(N,N);

w=ones(N,1);
rho=1;
rho0=1;

for i=1:snapshots
    n=sqrt(s_n^2/2)*randn(N,1)+j*sqrt(s_n^2/2)*randn(N,1);
    r=Am*s+n;
    y=w'*r;
    R_estimate=(R_estimate*(i-1)+r*r')/i;
    
    S_estimate=(S_estimate*(i-1)+diag(r*conj(y)))/i;
    nu=trace(abs(S_estimate))/N;
    F=nu*I;
    dd=rho*diag(F)+(1-rho)*diag(S_estimate);
    D=diag(dd);
    rho=((1-2/N)*real(trace(D*conj(S_estimate)))+trace(D)*conj(trace(D)))/((i+1-2/N)*real(trace(D*conj(S_estimate)))+(1-i/N)*trace(D)*conj(trace(D)));
    a1=P*dd/norm(P*dd,2);
    
    nu0=trace(R_estimate)/N;
    F0=nu0*I;
    RR=rho0*F0+(1-rho0)*R_estimate;
    rho0=((1-2/N)*trace(RR*R_estimate)+trace(RR)^2)/((i+1-2/N)*trace(RR*R_estimate)+(1-i/N)*trace(RR)^2);
    
    P1_estimate=abs((a1'*R_estimate*a1-(a1'*a1)*s_n^2)/(a1'*a1)^2);
    RR=RR+norm(RR)*I;
    RR=RR-P1_estimate*a1*a1';
    RR=RR*2*s_n^2/norm(RR);
    RRinv=inv(RR);
    
    w=RRinv*a1/(a1'*RRinv*a1);
    sinr(i,l)=P1_estimate*abs(w'*a1)^2/(w'*RR*w);
end;
end;
sinr=mean(sinr,2);
sinr(1)=1/snr;
axis=[1 (10:10:snapshots)].';
sinr_p=[sinr(1) sinr(10:10:snapshots).'].';
plot(axis,10*log10(abs(sinr_p)),'r--d');
xlabel('snapshots');
ylabel('SINR (dB)');
legend('LOCSME');